﻿using System;
using Microsoft.Phone.Shell;
using WPCordovaClassLib.Cordova;
using WPCordovaClassLib.Cordova.Commands;
using PushipPlugin;
using PushipPlugin.Classes;

namespace Cordova.Extension.Commands
{
    public class PushipPlugin : BaseCommand
    {
        public PushipPlugin()
        {
            NotificationService.OnPushAccepted += NotificationService_OnPushAccepted;
        }

        void NotificationService_OnPushAccepted(object sender, CustomEventArgs<string> e)
        {
            //InvokeCustomScript(new ScriptCallback("Puship.WP.NotificationCallback", new string[1] { e.Result }), false);
            InvokeCustomScript(new ScriptCallback("PushipWPNotificationCallback", new string[1] { e.Result }), false);
        }
        private static NotificationService NotificationService
        {
            get { return ((PhonePushApplicationService) PhoneApplicationService.Current).NotificationService; }
        }

        public void GetUserToken(string options)
        {
            if (!string.IsNullOrEmpty(NotificationService.PushToken))
                DispatchCommandResult(new PluginResult(PluginResult.Status.OK, NotificationService.PushToken));

            NotificationService.OnPushTokenUpdated += OnPushTokenUpdated;
        }

        private void OnPushTokenUpdated(object sender, CustomEventArgs<Uri> e)
        {
            DispatchCommandResult(new PluginResult(PluginResult.Status.OK, e.Result.ToString()));
        }



    }
}
